#include <fxlib.h>
#include <stdlib.h>
#include "HEXEDIT.h"
#include "MonochromeLib.h"
#include "File.h"
#include "BetterFont.h"
#include "EasyInput.h"

#define _MODIF_MAX 500
#define _SIZE_SAVE 48000
enum {_UNDO,_SAVE,_ERROR_OPENING_FILE,_CANNOT_CHANGE,_NOT_ENOUGH_MEMORY,_CREATE_NEW_FILE,_FILE_ALREADY_EXISTS,_ERROR_SAVING_FILE,_ERROR_CREATING_FILE};

static int Tab_modif_pos[_MODIF_MAX];
static unsigned char Tab_modif[_MODIF_MAX];
static FONTCHARACTER New_File_Name[14] = {0};

int AddIn_main(int isAppli, unsigned short OptionNum) {
	const unsigned char BTM[]={0xff,0xff,0xff,0xc6,0xb,0xbf,0xdb,0xb9,0x3f,0xc7,0xba,0xbf,0xdb,0xba,0xbf,0xc7,0xbb,0xbf,0xff,0xff,0xff,};
	const unsigned char PgDn[]={0xff,0xff,0xff,0xc7,0xe3,0xff,0xdb,0x2d,0x3f,0xc6,0xad,0x5f,0xdf,0x2d,0x5f,0xdf,0xa3,0x5f,0xfe,0x7f,0xff,};
	const unsigned char PgUp[]={0xff,0xff,0xff,0xc7,0xed,0xff,0xdb,0x2d,0x3f,0xc6,0xad,0x5f,0xdf,0x2d,0x3f,0xdf,0xb3,0x7f,0xfe,0x7f,0x7f,};
	const unsigned char TOP[]={0xff,0xff,0xff,0xc1,0x98,0x7f,0xf7,0x6b,0xbf,0xf7,0x68,0x7f,0xf7,0x6b,0xff,0xf7,0x9b,0xff,0xff,0xff,0xff,};
	const unsigned char Fleche_Droite[]={0x7f,0xf7,0xbf,0xff,0xf3,0xff,0xe0,0x9,0xff,0xef,0xfc,0xff,0xe0,0x9,0xff,0xff,0xf3,0xff,0x7f,0xf7,0xbf,};
	const unsigned char Fleche_Gauche[]={0x7b,0xff,0xbf,0xf3,0xff,0xff,0xe4,0x1,0xff,0xcf,0xfd,0xff,0xe4,0x1,0xff,0xf3,0xff,0xff,0x7b,0xff,0xbf,};
	const unsigned char UNDO[]={0xff,0xff,0xff,0xb5,0xa3,0x9f,0xb4,0xad,0x6f,0xb5,0x2d,0x6f,0xb5,0xad,0x6b,0xcd,0xa3,0x93,0xff,0xff,0xe3,};
	unsigned char T[105] = "", hex[3] = "", Nb_Hex, *File_content = NULL;
	unsigned int key;
	int handle, new_handle, x, y, current_disp, File_size, curseur_max, position_modif, i;
	FONTCHARACTER Path_Name[]={'\\','\\','f','l','s','0','\\','*',0};
	FONTCHARACTER File[13], Path_To_File[50], File_To_Open[63];
	opt_tri mon_tri = DOSSIERS_DEVANT_ORDRE_ALPHABETIQUE;

	do {
		if(User_Choose_File(Path_Name, Path_To_File, File, 50, mon_tri, 1, 1) == 1)
			return 0;

		FONTCHARACTER_cat(Path_To_File, File, File_To_Open);
		handle = Bfile_OpenFile(File_To_Open, _OPENMODE_READ);
		if(handle < 0) Message(_ERROR_OPENING_FILE);

		else {
			Tab_modif_pos[0] = -1;
			position_modif = 0;
			Nb_Hex = 13;
			current_disp = 0;
			File_size = Bfile_GetFileSize(handle);

			ML_clear_vram();
			Afficher_FONTCHARACTER(File, 1, 0, 1);
			ML_rectangle(61, 0, 73, 7, 0, 0, ML_WHITE);
			dispStr("Size", 64, 0);
			dispStr(":", 81, 0);
			dispStr("%", 124, 0);
			Afficher_Nombre(File_size, 85, 0, 1);
			ML_rectangle(0, 0, 127, 7, 0, 0, ML_XOR);
			ML_vertical_line(61, 0, 7, ML_WHITE);
			ML_vertical_line(110, 0, 7, ML_WHITE);

			do {
				curseur_max = Nb_Hex * ((File_size-1)/Nb_Hex - 7);
				if(Nb_Hex == 8) ML_vertical_line(78, 8, 56, ML_BLACK);

				if(Tab_modif_pos[0] != -1) ML_bmp_or(UNDO, 86, 57, 22, 7);

				ML_rectangle(112, 0, 123, 6, 0, 0, ML_WHITE);
				if(File_size > (Nb_Hex*8)) {
					if(current_disp < curseur_max) {
						ML_bmp_or(BTM, 22, 57, 19, 7);
						ML_bmp_or(PgDn, 64, 57, 19, 7);
					}
					if(current_disp) {
						ML_bmp_or(TOP, 0, 57, 20, 7);
						ML_bmp_or(PgUp, 43, 57, 19, 7);
					}
					Afficher_Nombre(current_disp*100/curseur_max, 112, 0, 1);
				}
				else {
					Afficher_Nombre(100, 112, 0, 1);
					current_disp = 0;
				}
				ML_rectangle(112, 0, 123, 6, 0, 0, ML_XOR);

				if(Nb_Hex == 8) ML_bmp_or(Fleche_Droite, 110, 57, 18, 7);
				else ML_bmp_or(Fleche_Gauche, 110, 57, 18, 7);

				Bfile_ReadFile(handle, T, 8*Nb_Hex, current_disp);
				if(Tab_modif_pos[0] != -1) Change_T(T, current_disp);
				for(y = 1; y < 9; y ++) {
					for(x = 0; x < Nb_Hex; x++) {
						if(((x + Nb_Hex*(y-1)) + current_disp) >= File_size)	break;
						Get_Hex(hex, T[x + Nb_Hex* (y-1)] );
						dispStr(hex, 10*x, y*6+2);
						if(Nb_Hex == 8) {
							hex[1] = '\0';
							hex[0] = T[x + Nb_Hex* (y-1)];
							PrintMini(6*x + 80, y*6+3, hex, 0);
						}
					}
				}
				x = (position_modif-current_disp)%Nb_Hex;
				y = (position_modif-current_disp)/Nb_Hex;
				ML_rectangle(x*10-1, y*6+8, x*10+7, y*6+14, 0, 0, ML_XOR);
				if(Nb_Hex == 8) ML_rectangle(x*6+79, y*6+8, x*6+85, y*6+14, 0, 0, ML_XOR);

				GetKey(&key);
				if(key == KEY_CTRL_EXE) {
					SaveDisp(SAVEDISP_PAGE1);
					if(Last_Modif() < _MODIF_MAX) {
						Modifier_octet(T[Nb_Hex*y+x], position_modif);
						ML_clear_vram();
						RestoreDisp(SAVEDISP_PAGE1);
					}
					else Message(_CANNOT_CHANGE);
				}

				if((key==KEY_CTRL_DOWN) && (current_disp < curseur_max)) current_disp += Nb_Hex;
				if((key==KEY_CTRL_UP) && current_disp) current_disp -= Nb_Hex;
				if(key == KEY_CTRL_F1)	current_disp = 0;
				if(key == KEY_CTRL_F2)	current_disp = curseur_max;
				if(key == KEY_CTRL_F4)	current_disp += (Nb_Hex*8);
				if(key == KEY_CTRL_F3)	current_disp -= (Nb_Hex*8);
				if(key == KEY_CTRL_F6){
					if(Nb_Hex == 13) Nb_Hex = 8;
					else Nb_Hex = 13;
					curseur_max = Nb_Hex * ((File_size-1)/Nb_Hex - 7);
				}
				if(current_disp < 0) current_disp = 0;
				else if(current_disp > curseur_max) current_disp = curseur_max;

				if(key == KEY_CHAR_6) position_modif++;
				else if(key == KEY_CHAR_4) position_modif--;
				else if(key == KEY_CHAR_2) position_modif += Nb_Hex;
				else if(key == KEY_CHAR_8) position_modif -= Nb_Hex;
				if(position_modif < 0) position_modif = 0;
				if(position_modif >= File_size) position_modif = File_size-1;
				while((position_modif-current_disp)/Nb_Hex > 7) position_modif -= Nb_Hex;
				while((position_modif-current_disp-Nb_Hex+1)/Nb_Hex < 0) position_modif += Nb_Hex;

				if(key==KEY_CTRL_F5 && Tab_modif_pos[0]!=-1) {
					SaveDisp(SAVEDISP_PAGE1);
					if(Message(_UNDO)) {
						Tab_modif_pos[Last_Modif()-1] = -1;
						Complet();
					}
					ML_clear_vram();
					RestoreDisp(SAVEDISP_PAGE1);
				}

				ML_rectangle(0, 8, 127, 63, 0, 0, ML_WHITE);
			}while(key != KEY_CTRL_EXIT);

			if(Tab_modif_pos[0] != -1) if(Message(_SAVE)) {
				x = -1;
				while(x < 0) {
					Message(_CREATE_NEW_FILE);
					FONTCHARACTER_cat(Path_To_File, New_File_Name, File_To_Open);
					x = Bfile_CreateFile(File_To_Open, File_size);
					if(x == IML_FILEERR_ALREADYEXISTENTRY) Message(_FILE_ALREADY_EXISTS);
					else if(x < 0) {
						if(x == IML_FILEERR_DEVICEFULL) Message(_NOT_ENOUGH_MEMORY);
						else Message(_ERROR_CREATING_FILE);
						break;
					}
					else {
						new_handle = Bfile_OpenFile(File_To_Open, _OPENMODE_WRITE);
						if(new_handle < 0) {
							Message(_ERROR_OPENING_FILE);
							break;
						}
						File_content = malloc(_SIZE_SAVE);
						if(File_content == NULL) {
							File_content = malloc(_SIZE_SAVE/2);
							if(File_content == NULL) {
								Message(_ERROR_SAVING_FILE);
								break;
							}
						}

						PopUpWin(1);
						Locate__Print(6, 4, "Chargement...");
						ML_display_vram();

						Bfile_SeekFile(handle, 0);
						x = 0;
						while(x < File_size) {
							Bfile_ReadFile(handle, File_content, _SIZE_SAVE, -1);
							for(y = 0; y < Last_Modif(); y++) {
								i = Tab_modif_pos[y];
								if((i >= x) && (i <= x+_SIZE_SAVE)) File_content[i-x] = Tab_modif[y];
							}
							y = _SIZE_SAVE;
							if(x+_SIZE_SAVE > File_size) y = File_size-x;
							if(Bfile_WriteFile(new_handle, File_content, y) < 0) Message(_ERROR_SAVING_FILE);
							x += _SIZE_SAVE;
						}

						free(File_content);
					}
					Bfile_CloseFile(handle);
					Bfile_CloseFile(new_handle);
				}
				if(x>= 0 && File_content!=NULL) Complet();
			}
			
		}

		x = 0;
		while(Path_To_File[x]) {
			Path_Name[x] = Path_To_File[x];
			x++;
		}
		Path_Name[x] = '*';
		Path_Name[x+1] = '\0';
	} while(1);
	
	return 1;
}

int Last_Modif(void) {
	int i = 0;
	while(Tab_modif_pos[i] != -1) i++;
	return i;
}
int Message(int m) {
	const unsigned char NON[]={0xff,0xff,0xff,0x80,0x0,0x1f,0xb8,0xce,0x1f,0xa5,0x29,0x1f,0xa5,0x29,0x1f,0xa5,0x29,0x1f,0xa4,0xc9,0x1f,};
	const unsigned char OUI[]={0xff,0xff,0xff,0x80,0x0,0x1f,0x99,0x2e,0x1f,0xa5,0x24,0x1f,0xa5,0x24,0x1f,0xa5,0x24,0x1f,0x98,0xce,0x1f,};
	unsigned char *new_name = 0;
	int i = 1;
	unsigned int key;

	if(m==_UNDO || m==_SAVE) {
		ML_rectangle(0, 57, 127, 63, 0, 0, ML_WHITE);
		PopUpWin(5);
		if(m == _UNDO) {
			Locate__Print(3, 2, "Annuler derni\xe6\x09re");
			Locate__Print(4, 3, "modification ?");
		}
		else {
			Locate__Print(3, 2, "Sauvegarder les");
			Locate__Print(4, 3, "modifications ?");
		}
		Locate__Print(3, 5, "[F1]: Oui");
		Locate__Print(3, 6, "[F6]: Non");
		ML_bmp_or(OUI, 1, 57, 19, 7);
		ML_bmp_or(NON, 108, 57, 19, 7);
		do {
			GetKey(&key);
			if (key==KEY_CTRL_F6) return 0;
		} while(key != KEY_CTRL_F1);
	}
	else if(m != _CREATE_NEW_FILE){
		if(m == _CANNOT_CHANGE) {
			PopUpWin(2);
			Locate__Print(3, 3, "Erreur: maximum");
			Locate__Print(7, 4, "modifications");
			Afficher_Nombre(_MODIF_MAX, 12, 24, 0);
		}
		else {
			PopUpWin(4);
			if(m == _FILE_ALREADY_EXISTS) Locate__Print(5, 3, "Existe d\xe6\x0aj\xe6\x01.");
			else if(m == _ERROR_SAVING_FILE) Locate__Print(3, 3, "Erreur sauvegarde");
			else if(m == _ERROR_CREATING_FILE) Locate__Print(4, 3, "Erreur cr\xe6\x0a""ation");
			else if(m == _NOT_ENOUGH_MEMORY) {
				Locate__Print(3, 2, "Pas assez de");
				Locate__Print(3, 3, "m\xe6\x0amoire !");
			}
			else if(m == _ERROR_OPENING_FILE)  Locate__Print(3, 3, "Erreur ouverture");
			Locate__Print(4, 5, "Appuyer:[EXIT]");
		}
		do {
			GetKey(&key);
		} while(key!=KEY_CTRL_EXIT && key!=KEY_CTRL_AC && key!=KEY_CTRL_EXE);
	}
	else {
		PopUpWin(3);
		Locate__Print(3, 3, "Entrer le nouveau");
		Locate__Print(3, 4, "nom du fichier :");
		EI_manage_config(EI_SET_COLUMN, 3);
		EI_manage_config(EI_SET_ROW , 5);
		EI_manage_config(EI_SET_START_MODE, EI_ALPHA_LOCKED);
		
		while(i) {
			new_name = EI_input_string(12, (const char*)"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.\"");
			if(new_name == (char*)0) ML_rectangle(13, 32, 90, 38, 0, 0, ML_WHITE);
			else if(new_name[0]) i = 0;
		}
		while(new_name[i]) {
			New_File_Name[i] = new_name[i];
			i++;
		}
		New_File_Name[i] = 0;
	}
	return 1;
}
void Change_T(unsigned char T[], int current_disp) {
	int j, a;
	for(j = 0; j < Last_Modif(); j++) {
		a = Tab_modif_pos[j];
		if((a >= current_disp) && (a <= current_disp+104))
			T[a-current_disp] = Tab_modif[j];
	}
}
int Modifier_octet(unsigned char c, int p_modif) {
	unsigned int key;
	unsigned char hex[3] = "", ascii[2] = "", *new_hex = 0;
	int n = 24, i;
	Get_Hex(hex, c );
	ascii[0] = c;
	do {
		ML_rectangle(0, 57, 127, 63, 0, 0, ML_WHITE);
		i = 0;
		PopUpWin(4);
		Locate__Print(4, 2, "Modifier Octet :");
		Locate__Print(3, 4, "Hex :      \xe6\x91");
		Locate__Print(3, 5, "ASCII :\" \" \xe6\x91 \" \"");
		Locate__Print(10, 4, hex);
		Locate__Print(11, 5, ascii);
	
		do {
			ML_rectangle(11, n, 114, n+7, 0, 0, ML_XOR);
			GetKey(&key);
			ML_rectangle(11, n, 114, n+7, 0, 0, ML_XOR);

			if(key==KEY_CTRL_DOWN && n==24) n = 32;
			if(key==KEY_CTRL_UP && n==32) n = 24;

			if(key == KEY_CTRL_EXIT) return 0;
		} while(key != KEY_CTRL_EXE);

		EI_init();
		if(n == 24) {
			EI_manage_config(EI_SET_COLUMN, 16);
			EI_manage_config(EI_SET_ROW , 4);
			EI_manage_config(EI_SET_START_MODE, EI_NORMAL);
		}
		else {
			EI_manage_config(EI_SET_COLUMN, 17);
			EI_manage_config(EI_SET_ROW , 5);
			EI_manage_config(EI_SET_START_MODE, EI_ALPHA_LOCKED);
		}
		
		while(i == 0) {
			if(n == 24) new_hex = EI_input_string(2, (const char*)"0123456789abcdef");
			else new_hex = EI_input_string(1, (const char*)"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789.,+-/*()[]{} #\"");
			if(new_hex == (char*)0) i = 2;
			else if(n==24 && new_hex[1] == '\0') i = 2;
			else if(identique(new_hex, c, n)) i = 2;
			else i = 1;
		}
	} while(i != 1);

	i = Last_Modif();
	Tab_modif_pos[i] = p_modif;
	if (n == 24) Tab_modif[i] = Get_Bin(new_hex);
	else Tab_modif[i] = new_hex[0];
	Tab_modif_pos[i+1] = -1;

	Complet();
	return 0;
}
int identique(const unsigned char hex[], char c, char n) {
	char new_c;
	if (n == 24) new_c = Get_Bin(hex);
	else new_c = hex[0];
	if(new_c == c) return 1;
	return 0;
}

void Locate__Print(int x, int y, const unsigned char s[]) {
	locate(x, y);
	Print(s);
}
void Get_Hex(unsigned char hex[], unsigned char n){
	char s[] = "0123456789abcdef";
	hex[0] = s[(int)(n/16)];
	while(n >= 16)
		n -= 16;
	hex[1] = s[n];
}
unsigned char Get_Bin(const unsigned char hex[]) {
	int a = hex[0] - 48, b = hex[1] - 48;
	if(a > 9) a -= 39;
	if(b > 9) b -= 39;
	return 16*a + b;
}
void Complet(void) {
	unsigned int key;
	PopUpWin(4);
	Locate__Print(7, 3, "Complet!");
	Locate__Print(4, 5, "Appuyer:[EXIT]");
	do {
		GetKey(&key);
	} while(key!=KEY_CTRL_EXIT && key!=KEY_CTRL_EXE);
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum) { return INIT_ADDIN_APPLICATION(isAppli, OptionNum); }
#pragma section
